; Perseus Automation
;
; ===========================================================================================================================
; Impressum
; (C) Dr. Matthias Zwoch 2008
;
;    This script is freeware and is available for all hobbyists for free
;    Using this scrip is only on your own risk. Pay attention to the notes in the readme file
;    Matthias Zwoch is not taking any responsibility or obligations 
;    Spreading and modifications of this script are allowed as long as these are documented 
;    in this impression 
;    This file is an English translation (by Guido Schotmans) of the original German laguage 
;    script that is available on the web page of SSB-Electronics http://www.ssb.de.
;    Guido Schotmans made also some modifications to handle closing better and introduced some 
;    settings (WFall screen, 0.8 kHz Bandwidth and minimizing application) that will keep 
;    the CPU usage lower. 
;	 
;    * Script adjusted by Ken Baird, Scotland (www.ayrshirehistory.eu/tadx) for PERSEUS 2.1f
;	 after some buttons were moved by Microtelecom * 
;	 * No annoying pop up box now about aerials being connected *
;    * Folder name in the style of "2009.09.03" *
;       	
; ===========================================================================================================================
;
;    Starttime, Stoptime, Spanwidth, and  destination folder determination
;    Times : your PC time ! (normally your LOCAL time)
;
;    Put together for Autohotkey Version 1.0.47.01 Download von www.autohotkey.com 
;    You will also need pskill.exe Download from http://download.sysinternals.com/Files/PsTools.zip
;
;---------------------------
;  Parameters
;---------------------------
Starttime := 1258          ;This is the Starttime in 4 figures only in your local time (PC time) 
Stoptime :=  1302        ;Stoptime, as above
midfreq := "960"          ;Center frequency
Bandwidth := 1600           ;Bandwidth. Set Bandwidth in kHz : 100,200,400,800 or 1600 kHz.
RecFile := "1300" ;Wav file name. Keep the file name very short AND DON'T USE UNDERSCORES !
Shutdown := "No"           ;Put here "Yes" or "No" for shutdown PC after recording. Make sure that upper and lower case characters are as in the example
;
;
;---------------------------
;  Constants, edit these 
;  to fit with your system
;---------------------------
;
ToRun := "C:\perseus\perseus_new\perseus.exe"  ;This is the Perseus Directory
WorkDir := "C:\perseus\perseus_new"                ;This is the Work Directory, otherwise it will not find the files
BaseDir :="F:\perseus files"                                      ;Root Directory for recording Files
PsKill := "C:\perseus\perseus_new\pskill.exe -t perseus.exe /accepteula"   ;To kill hanging Perseus processes
;
;---------------------------
;  Initialising
;---------------------------
;
; Arbeitsverzeichnis fr abzulegende Dateien im Wurzelverzeichnis aufbauen
; Perseus.exe vertrgt keine _ im vorgegebenem Dateinamen, daher hssliche Trennung mit "x"
;
SetDefaultMouseSpeed,10
FileDir = %BaseDir%\%A_YYYY%.%A_MM%.%A_DD%
;
;---------------------------
;  General program
;---------------------------
;
gosub,WaitForStart       ;Wait untill the Start Time is reached
gosub,StartPerseus       ;Start and control the Perseus
gosub,WaitForEnd         ;wating for End time during recording
gosub,StopPerseus        ;Stop Perseus 
gosub,GoSleep            ;This is the Close Script and will shut down the PC when needed
;
;
;---------------------------
;  Subroutine WaitForStart
;---------------------------
;
;
;  Waiting 
WaitForStart:
loop
{
  CurTime := (A_hour*100)+A_min    ;Putting together the local PC time in four digits
  if (CurTime = Starttime)         ;Is this the Starting Time
  {
    break                          ;Then it will start
  }
  sleep,15000                      ;otherwise wait for 15 sec and check again
}    
return
;
;---------------------------
;  Subroutine StartPerseus
;  Starts the recording and
;  "controls" the Perseus
;---------------------------
;
StartPerseus:
; This will create a new Work Directory
run,cmd                            ;opening the DOS Shell
sleep,2000                         ;Wait untill it can be used
send mkdir {"}%Filedir%{"}{Enter}  ;Send mkdir Command
sleep,1000                         ;Wait 1 second
send exit{Enter}                   ;close DOS Shell
;This will kill still hanging Perseus.exe Zombies 
run,%PsKill%
sleep,2000
run,%ToRun%,%WorkDir%              ;Call Perseus.exe 
sleep,6000                         ;Wait untill initialising end
MouseClick,,260,310,               ;Activate WFall to reduce CPU usage
sleep,500                          ;Wait half a second
MouseClick,,195,520,               ;Activate 0,8 kHz Bandwith to reduce CPU usage
sleep,500                          ;Wait half a second
MouseClick,,300,309,               ;Activate Zoom to reduce CPU usage
sleep,500                          ;Wait half a second
; This will activate the Bandwidth
if (Bandwidth = 100)
{
  MouseClick,,18,475               ;click Button SamplingRate 125 1 x 
}
if (Bandwidth = 200)
{
  MouseClick,,48,475               ;click Button SamplingRate 250 1 x 
}
if (Bandwidth = 400)
{
  MouseClick,,81,475               ;click Button SamplingRate 500 1 x 
}
if (Bandwidth = 800)
{
  MouseClick,,113,475,             ;click Button SamplingRate 1000 1 x 
}
if (Bandwidth = 1600)
{
  MouseClick,,145,475,             ;click Button SamplingRate 2000 1 x 
}
MouseClick,,100,245,2              ;Dobbleclick the Frequencyfield to bring up the Frequencydialog
sleep,1000                         ;Wait 1 second
MouseClick,,70,45                  ;Click in the Frequenyfield
send %midfreq%                     ;Type the centre frequency
MouseClick,,64,181                ;Click OK
MouseClick,,99,180                 ;Click Close
sleep,1000                         ;Wait 1 second
MouseClick,,110,595                ;Click Recording Button
sleep,1000                         ;Wait 1 second
MouseClick,,100,215                ;Click in the dialog field
send %Filedir%\%Recfile%           ;Enter the directory and recording file name
MouseClick,,360,210                ;Click OK
WinMinimize,Perseus                ;Minimize Perseus to keep CPU usage low
return                             ;
;
;---------------------------
;  Subroutine WaitForEnd
;  Waiting for the StopTime 
;  of the recording
;---------------------------
;
WaitForEnd:
loop
{
  CurTime := (A_hour*100)+A_min    ;Current Time in 4 digit format
  if (CurTime = Stoptime)          ;Is this the Stop Time ?
  {
    break                          ;If yes then execute it
  } 
  sleep,15000                      ;otherwise wait again for recording end.
}    
return
;
;---------------------------
;  Subroutine StopPerseus
;  This will stop the recording
;  and closes Perseus.exe
;---------------------------
;
StopPerseus:
WinMaximize,Perseus                ;Unminimize Perseus to make it able to use it.
sleep,2000                         ;Wait 2 seconds
MouseClick,,30,600                 ;Click RecorderStop Button 
MouseClick,,1010,13                ;Close Perseus by clicking x-button
sleep,2000                         ;Wait 2 seconds
WinClose,Perseus                   ;Send a closing command too, to be sure
sleep,3000                         ;Wait 3 seconds
run,%PsKill%                       ;Kill hanging Persues processes
return
;
;---------------------------
;  Subroutine GoSleep
;  This will close the running script and wait for the next one
;  or it will shutdown the PC
;---------------------------
;
;
GoSleep:
if (Shutdown = "Yes")
{
  sleep 3000
  shutdown,1                        ;Try to shutdown softly
  sleep 30000                       ;Still there ?
  shutdown,9                        ;Force a shutdown
}
exit  
return                              ;
